<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_201) on Tue Jun 11 21:47:09 AEST 2019 -->
<title>EditSessionEvent (worldedit-core 7.0.0 API)</title>
<meta name="date" content="2019-06-11">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="EditSessionEvent (worldedit-core 7.0.0 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/worldedit/event/extent/EditSessionEvent.html" target="_top">Frames</a></li>
<li><a href="EditSessionEvent.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">com.sk89q.worldedit.event.extent</div>
<h2 title="Class EditSessionEvent" class="title">Class EditSessionEvent</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li><a href="../../../../../com/sk89q/worldedit/event/Event.html" title="class in com.sk89q.worldedit.event">com.sk89q.worldedit.event.Event</a></li>
<li>
<ul class="inheritance">
<li>com.sk89q.worldedit.event.extent.EditSessionEvent</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="typeNameLabel">EditSessionEvent</span>
extends <a href="../../../../../com/sk89q/worldedit/event/Event.html" title="class in com.sk89q.worldedit.event">Event</a></pre>
<div class="block">Raised (several times) when a new <a href="../../../../../com/sk89q/worldedit/EditSession.html" title="class in com.sk89q.worldedit"><code>EditSession</code></a> is being instantiated.

 <p></p>Block loggers, as well as block set interceptors, can use this event to wrap
 the given <a href="../../../../../com/sk89q/worldedit/extent/Extent.html" title="interface in com.sk89q.worldedit.extent"><code>Extent</code></a> with their own, which would allow them to intercept
 all changes made to the world. For example, the code below would wrap the
 existing extent with a custom one, and the custom extent would receive
 all method calls <strong>before</strong> the extent fetched from
 <a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html#getExtent--"><code>getExtent()</code></a> would.</p>

 <pre>
 event.setExtent(new MyExtent(event.getExtent())
 </pre>

 <p></p>This event is fired several times during the creation of a single
 <a href="../../../../../com/sk89q/worldedit/EditSession.html" title="class in com.sk89q.worldedit"><code>EditSession</code></a>, but <a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html#getStage--"><code>getStage()</code></a> will differ each time.
 The stage determines at which point <a href="../../../../../com/sk89q/worldedit/extent/Extent.html" title="interface in com.sk89q.worldedit.extent"><code>Extent</code></a>s added to this event
 will be called. For example, if you inject an extent when the stage
 is set to <a href="../../../../../com/sk89q/worldedit/EditSession.Stage.html#BEFORE_HISTORY"><code>EditSession.Stage.BEFORE_HISTORY</code></a>, then you can drop (or log) changes
 before the change has reached the history, reordering, and actual change
 extents, <em>but</em> that means that any changes made with
 <a href="../../../../../com/sk89q/worldedit/EditSession.html#rawSetBlock-com.sk89q.worldedit.math.BlockVector3-B-"><code>EditSession.rawSetBlock(BlockVector3, BlockStateHolder)</code></a> will skip your
 custom <a href="../../../../../com/sk89q/worldedit/extent/Extent.html" title="interface in com.sk89q.worldedit.extent"><code>Extent</code></a> because that method bypasses history (and reorder).
 It is thus recommended that loggers intercept at <a href="../../../../../com/sk89q/worldedit/EditSession.Stage.html#BEFORE_CHANGE"><code>EditSession.Stage.BEFORE_CHANGE</code></a>
 and block interceptors intercept at BOTH <a href="../../../../../com/sk89q/worldedit/EditSession.Stage.html#BEFORE_CHANGE"><code>EditSession.Stage.BEFORE_CHANGE</code></a> and
 <a href="../../../../../com/sk89q/worldedit/EditSession.Stage.html#BEFORE_HISTORY"><code>EditSession.Stage.BEFORE_HISTORY</code></a>.</p></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html#EditSessionEvent-com.sk89q.worldedit.world.World-com.sk89q.worldedit.extension.platform.Actor-int-com.sk89q.worldedit.EditSession.Stage-">EditSessionEvent</a></span>(<a href="../../../../../com/sk89q/worldedit/world/World.html" title="interface in com.sk89q.worldedit.world">World</a>&nbsp;world,
                <a href="../../../../../com/sk89q/worldedit/extension/platform/Actor.html" title="interface in com.sk89q.worldedit.extension.platform">Actor</a>&nbsp;actor,
                int&nbsp;maxBlocks,
                <a href="../../../../../com/sk89q/worldedit/EditSession.Stage.html" title="enum in com.sk89q.worldedit">EditSession.Stage</a>&nbsp;stage)</code>
<div class="block">Create a new event.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code><a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html" title="class in com.sk89q.worldedit.event.extent">EditSessionEvent</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html#clone-com.sk89q.worldedit.EditSession.Stage-">clone</a></span>(<a href="../../../../../com/sk89q/worldedit/EditSession.Stage.html" title="enum in com.sk89q.worldedit">EditSession.Stage</a>&nbsp;stage)</code>
<div class="block">Create a clone of this event with the given stage.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code><a href="../../../../../com/sk89q/worldedit/extension/platform/Actor.html" title="interface in com.sk89q.worldedit.extension.platform">Actor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html#getActor--">getActor</a></span>()</code>
<div class="block">Get the actor for this event.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="../../../../../com/sk89q/worldedit/extent/Extent.html" title="interface in com.sk89q.worldedit.extent">Extent</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html#getExtent--">getExtent</a></span>()</code>
<div class="block">Get the <a href="../../../../../com/sk89q/worldedit/extent/Extent.html" title="interface in com.sk89q.worldedit.extent"><code>Extent</code></a> that can be wrapped.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html#getMaxBlocks--">getMaxBlocks</a></span>()</code>
<div class="block">Get the maximum number of blocks that may be set.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="../../../../../com/sk89q/worldedit/EditSession.Stage.html" title="enum in com.sk89q.worldedit">EditSession.Stage</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html#getStage--">getStage</a></span>()</code>
<div class="block">Get the stage that is being wrapped.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../../../../../com/sk89q/worldedit/world/World.html" title="interface in com.sk89q.worldedit.world">World</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html#getWorld--">getWorld</a></span>()</code>
<div class="block">Get the world.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html#setExtent-com.sk89q.worldedit.extent.Extent-">setExtent</a></span>(<a href="../../../../../com/sk89q/worldedit/extent/Extent.html" title="interface in com.sk89q.worldedit.extent">Extent</a>&nbsp;extent)</code>
<div class="block">Set a new extent that should be used.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="EditSessionEvent-com.sk89q.worldedit.world.World-com.sk89q.worldedit.extension.platform.Actor-int-com.sk89q.worldedit.EditSession.Stage-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>EditSessionEvent</h4>
<pre>public&nbsp;EditSessionEvent(@Nullable
                        <a href="../../../../../com/sk89q/worldedit/world/World.html" title="interface in com.sk89q.worldedit.world">World</a>&nbsp;world,
                        <a href="../../../../../com/sk89q/worldedit/extension/platform/Actor.html" title="interface in com.sk89q.worldedit.extension.platform">Actor</a>&nbsp;actor,
                        int&nbsp;maxBlocks,
                        <a href="../../../../../com/sk89q/worldedit/EditSession.Stage.html" title="enum in com.sk89q.worldedit">EditSession.Stage</a>&nbsp;stage)</pre>
<div class="block">Create a new event.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>world</code> - the world</dd>
<dd><code>actor</code> - the actor, or null if there is no actor specified</dd>
<dd><code>maxBlocks</code> - the maximum number of block changes</dd>
<dd><code>stage</code> - the stage</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getActor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getActor</h4>
<pre>@Nullable
public&nbsp;<a href="../../../../../com/sk89q/worldedit/extension/platform/Actor.html" title="interface in com.sk89q.worldedit.extension.platform">Actor</a>&nbsp;getActor()</pre>
<div class="block">Get the actor for this event.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the actor, which may be null if unavailable</dd>
</dl>
</li>
</ul>
<a name="getWorld--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getWorld</h4>
<pre>@Nullable
public&nbsp;<a href="../../../../../com/sk89q/worldedit/world/World.html" title="interface in com.sk89q.worldedit.world">World</a>&nbsp;getWorld()</pre>
<div class="block">Get the world.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the world</dd>
</dl>
</li>
</ul>
<a name="getMaxBlocks--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMaxBlocks</h4>
<pre>public&nbsp;int&nbsp;getMaxBlocks()</pre>
<div class="block">Get the maximum number of blocks that may be set.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the maximum number of blocks, which is -1 if unlimited</dd>
</dl>
</li>
</ul>
<a name="getExtent--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExtent</h4>
<pre>public&nbsp;<a href="../../../../../com/sk89q/worldedit/extent/Extent.html" title="interface in com.sk89q.worldedit.extent">Extent</a>&nbsp;getExtent()</pre>
<div class="block">Get the <a href="../../../../../com/sk89q/worldedit/extent/Extent.html" title="interface in com.sk89q.worldedit.extent"><code>Extent</code></a> that can be wrapped.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the extent</dd>
</dl>
</li>
</ul>
<a name="getStage--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getStage</h4>
<pre>public&nbsp;<a href="../../../../../com/sk89q/worldedit/EditSession.Stage.html" title="enum in com.sk89q.worldedit">EditSession.Stage</a>&nbsp;getStage()</pre>
<div class="block">Get the stage that is being wrapped.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the stage</dd>
</dl>
</li>
</ul>
<a name="setExtent-com.sk89q.worldedit.extent.Extent-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setExtent</h4>
<pre>public&nbsp;void&nbsp;setExtent(<a href="../../../../../com/sk89q/worldedit/extent/Extent.html" title="interface in com.sk89q.worldedit.extent">Extent</a>&nbsp;extent)</pre>
<div class="block">Set a new extent that should be used. It should wrap the extent
 returned from <a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html#getExtent--"><code>getExtent()</code></a>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>extent</code> - the extent</dd>
</dl>
</li>
</ul>
<a name="clone-com.sk89q.worldedit.EditSession.Stage-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>clone</h4>
<pre>public&nbsp;<a href="../../../../../com/sk89q/worldedit/event/extent/EditSessionEvent.html" title="class in com.sk89q.worldedit.event.extent">EditSessionEvent</a>&nbsp;clone(<a href="../../../../../com/sk89q/worldedit/EditSession.Stage.html" title="enum in com.sk89q.worldedit">EditSession.Stage</a>&nbsp;stage)</pre>
<div class="block">Create a clone of this event with the given stage.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>stage</code> - the stage</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a new event</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/worldedit/event/extent/EditSessionEvent.html" target="_top">Frames</a></li>
<li><a href="EditSessionEvent.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
